<?php

	global $article;
	global $dbConnStr;
	
	$database = pg_connect($dbConnStr);

	// very clever query, asks the meta table what the title is for links!
	$query    = 'SELECT link.*, meta.content '
		  . 'FROM link,meta '
		  . "WHERE (link.article='$article' OR link.article='*') "
		  . 'AND link.uri=meta.article '
		  . "AND meta.name='DC.title'";
	$result   = pg_query($database, $query);
		
	while ( $array = pg_fetch_array($result) )
	{
		$rel   = $array['relation'];
		$lang  = $array['lang'];
		$tit   = $array['title'];
		$uri   = $array['uri'];
		$type  = $array['type'];
		$media = $array['media'];
		$atit  = $array['content'];
			
		if ($uri != 'NULL')
		{

			echo "\t\t<link\trel=\"$rel\"\n";

			if ($lang)  { echo "\t\t\txml:lang=\"$lang\"\n";	}
	
			if ($tit)   { echo "\t\t\ttitle=\"$tit\"\n"; }
			else if ($atit) { echo "\t\t\ttitle=\"$atit\"\n"; }

			if ($type)  { echo "\t\t\ttype=\"$type\"\n"; }

			if ($media) { echo "\t\t\tmedia=\"$media\"\n"; }

			echo "\t\t\thref=\"" . make_uri($uri) . "\" />\n";

		}
	}

	// Now more queries for external links.
        $query    = 'SELECT * '
                  . 'FROM link '
                  . "WHERE (article='$article' OR article='*') "
                  . "AND (uri LIKE '%.%' OR uri LIKE '%\/%')";
        $result   = pg_query($database, $query);

        while ( $array = pg_fetch_array($result) )
        {
                $rel   = $array['relation'];
                $lang  = $array['lang'];
                $tit   = $array['title'];
                $uri   = $array['uri'];
                $type  = $array['type'];
                $media = $array['media'];

                if ($uri != 'NULL')
                {

                        echo "\t\t<link\trel=\"$rel\"\n";

                        if ($lang)  { echo "\t\t\txml:lang=\"$lang\"\n";        }

                        if ($tit)   { echo "\t\t\ttitle=\"$tit\"\n"; }
                        else if ($atit) { echo "\t\t\ttitle=\"$atit\"\n"; }

                        if ($type)  { echo "\t\t\ttype=\"$type\"\n"; }

                        if ($media) { echo "\t\t\tmedia=\"$media\"\n"; }

                        echo "\t\t\thref=\"" . make_uri($uri) . "\" />\n";

                }
        }

	
?>
