<?php
	function get_db_children ($a)
	{
		global $dbConnStr;
				
		$i = 1;
		
		$database = pg_connect($dbConnStr);

		$query    = 'SELECT link.article, meta.content '
			  . 'FROM link, meta '
			  . "WHERE link.uri='$a' "
			  . "AND link.relation='up' "
			  . "AND meta.name='DC.title' "
			  . 'AND link.article=meta.article '
			  . 'ORDER BY meta.content';

		$result   = pg_query($database, $query);
		
		while ($array = pg_fetch_array($result))
		{
			
			$r['title']   = $array['content'];
			$r['uri'] = $array['article'];

			$retval[$i++] = $r;
			
		}
		
		$retval[0] = $i - 1;
		
		return $retval;
		
	}
	
	function get_db_ancestors ($a)
	{

		global $dbConnStr;
		
		$database = pg_connect($dbConnStr);
		
		$attop = 0; //false
		$currentnode = $a;
		$i = 1;
		
		while ($attop < 1) //while attop is false
		{

			$query    = 'SELECT link.uri, meta.content '
				  . 'FROM link,meta '
				  . "WHERE link.article='$currentnode' "
				  . "AND link.relation='up' "
				  . 'AND link.uri=meta.article '
				  . "AND meta.name='DC.title'";
			$result   = pg_query($database,$query);	
			$array    = pg_fetch_array($result);
			
			$retval[$i]['uri'] = $array['uri'];

			if ($retval[$i]['uri'] == "NULL")
			{
				$attop = 1; //true
			}
			else
			{
				$retval[$i]['title'] = $array['content'];
			}
			
			$currentnode = $retval[$i]['uri'];
			$i++;
		}		
		
		$retval[0] = $i - 2;
		
		return $retval;
	}

	
	function create_nav_tree ($grannies,$kids,$tabs,$pagetitle)
	{
		
		$thislevel = $grannies[0];
		
		if ($thislevel > 0) {		// my ancestors

			$grannies[0]--;
			$newtabs = $tabs . "\t\t";

			$retval = $tabs . "<ul>\n"
				. $tabs . "\t<li class=\"ancestor\">\n"
				. $tabs . "\t\t<a accesskey=\"$thislevel\" href=\"" . make_uri($grannies[$thislevel]['uri']) . "\">"
				. $grannies[$thislevel]['title'] . "</a>\n"
				. create_nav_tree($grannies,$kids,$newtabs,$pagetitle)
				. $tabs . "\t</li>\n"
				. $tabs . "</ul>\n";

		}
		
		
		else if ($thislevel < 0) 	// my children
		{
			if ($kids[0] > 0) 
			{
				$retval = $tabs . "<ul>\n";
				for ($i = 1; $i<=$kids[0]; $i++)
				{
					$retval .= $tabs . "\t<li class=\"child\">\n"
						.  $tabs . "\t\t<a href=\"" . make_uri($kids[$i]['uri']) . "\">" . $kids[$i]['title']. "</a>\n"
						.  $tabs . "\t</li>\n";
				}
				$retval .= $tabs . "</ul>\n";
			}
			else
			{
				$retval = "";
			}
		}
		
		
		else 				// me, myself and i!!!
		{	$grannies[0]--;
			$newtabs = $tabs . "\t\t";
			
			$retval = $tabs . "<ul>\n"
				. $tabs . "\t<li class=\"me\">\n"
				. $tabs . "\t\t" . $pagetitle . "\n"
				. create_nav_tree($grannies,$kids,$newtabs,$pagetitle)
				. $tabs . "\t</li>\n"
				. $tabs . "</ul>\n";
		}
		
		return $retval;
	}

?>


			<div id="navtree">
				<h2>Navigation Tree</h2>
<?php 
        global $article;
        global $dbConnStr;

        $database = pg_connect($dbConnStr);
        $query    = "SELECT * FROM meta WHERE article='$article' and name='DC.title'";
        $result   = pg_query($database, $query);
        $array    = pg_fetch_array($result);
        $title    = $array['content'];
        echo create_nav_tree(get_db_ancestors($article), get_db_children($article), "\t\t\t\t", $title);
?>
			</div>
