<?php

	global $dbConnStr;
	global $q;
	
	$database = pg_connect($dbConnStr);

	// search through bodies
	$query = "SELECT id FROM articles WHERE       body ILIKE '% $q %' "
						. "OR body ILIKE '% $q.%' "
						. "OR body ILIKE '% $q,%' "
						. "OR body ILIKE '% $q?%' "
						. "OR body ILIKE '% $q-%' "
						. "OR body ILIKE '% $q!%';";
	$result   = pg_query($database, $query);
	while ( $array = pg_fetch_array($result) )
	{
		$scores[$array['id']] += 1;
	}
	
	// search through descriptions
	$query = "SELECT article FROM meta WHERE name='DC.description' AND ("
						.    "content ILIKE '% $q %' "
						. "OR content ILIKE '% $q.%' "
						. "OR content ILIKE '% $q,%' "
						. "OR content ILIKE '% $q?%' "
						. "OR content ILIKE '% $q-%' "
						. "OR content ILIKE '% $q!%');";
	$result   = pg_query($database, $query);
	while ( $array = pg_fetch_array($result) )
	{
		$scores[$array['article']] += 2;
	}
	
	// search through keywords
	$query = "SELECT article FROM meta WHERE name='DC.subject' AND ("
						.    "content ILIKE '%,$q,%' "
						. "OR content ILIKE '$q,%' "
						. "OR content ILIKE '%,$q');";
	$result   = pg_query($database, $query);
	while ( $array = pg_fetch_array($result) )
	{
		$scores[$array['article']] += 3;
	}
	
	// search through titles
	$query = "SELECT article FROM meta WHERE name='DC.title' AND ("
						.    "content ILIKE '%$q%' "
						. "OR content ILIKE '%$q' "
						. "OR content ILIKE '$q%' "
						. "OR content='$q');";
	$result   = pg_query($database, $query);
	while ( $array = pg_fetch_array($result) )
	{
		$scores[$array['article']] += 4;
		$title[$array['article']] = $array['content'];
	}
	
	if ($scores)
	{
		foreach($scores as $i => $j) {
			$scores2[$j] .= "$i;";
		}
	
		print "\t\t\t<p>Your results for a search on \"$q\"</p>\n";
		print "\t\t\t<ul class=\"searchresults\">\n";
		for($i = 10; $i>=0; $i--) {
			$resultsAtThisScore = preg_split('/\;/',$scores2[$i],-1,PREG_SPLIT_NO_EMPTY);
			foreach($resultsAtThisScore as $r) {
				$query    = "SELECT * FROM meta WHERE article='$r' and name='DC.title'";
			        $result   = pg_query($database, $query);
			        $array    = pg_fetch_array($result);
		        	$title    = $array['content'];
				$title    = preg_replace('/\"/', '&quot;', $title);
				print "\t\t\t\t<li><h2><a title=\"$title\" href=\"article.php?id=$r\">$title</a></h2><p><strong>Relevency:</strong> $i</p></li>\n";
			}
		}
		print "\t\t\t</ul>\n";
	}

	else
	{
		?>
			<p>Sorry, your search returned no results. Why not try
			the <a href="sitemap.php">site map</a>?</p>
		<?php
	}

?>
